RedHat: Munge future kernel versions
[openafs.git] / src / packaging / RedHat / openafs-kmodtool
1 #!/bin/bash
2
3 # kmodtool - Helper script for building kernel module RPMs
4 # Copyright (c) 2003-2007 Ville Skytt√§ <ville.skytta@iki.fi>,
5 #                         Thorsten Leemhuis <fedora@leemhuis.info>
6 #
7 # Modified by Simon Wilkinson for OpenAFS
8
9 # Permission is hereby granted, free of charge, to any person obtaining
10 # a copy of this software and associated documentation files (the
11 # "Software"), to deal in the Software without restriction, including
12 # without limitation the rights to use, copy, modify, merge, publish,
13 # distribute, sublicense, and/or sell copies of the Software, and to
14 # permit persons to whom the Software is furnished to do so, subject to
15 # the following conditions:
16 #
17 # The above copyright notice and this permission notice shall be
18 # included in all copies or substantial portions of the Software.
19 #
20 # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
21 # EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
22 # MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
23 # NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
24 # LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
25 # OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
26 # WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
27
28 shopt -s extglob
29
30 myprog="kmodtool"
31 myver="0.10.13"
32 knownvariants=@(BOOT|PAE?(-debug)|@(big|huge)mem|debug|enterprise|kdump|?(large)smp?(-debug)|uml|xen?([0U])?(-PAE))
33 kmod_name=
34 kver=
35 verrel=
36 variant=
37
38 get_verrel ()
39 {
40   verrel=${1:-$(uname -r)}
41   verrel=${verrel%%$knownvariants}
42   case "$verrel" in
43     *.el[6-9].elrepo*)
44                    verrel="`echo ${verrel} | sed -e 's/^\(.*.el[6-9].elrepo[^\.]*\)\.[^\.]\+.\?$/\1/'`" ;;
45     *.el[6-9]*)    verrel="`echo ${verrel} | sed -e 's/^\(.*.el[6-9][^\.]*\)\.[^\.]\+.\?$/\1/'`" ;;
46     *.fc[1-9][0-9]*)
47                    verrel="`echo ${verrel} | sed -e 's/^\(.*.fc[1-9][0-9][^\.]*\)\.[^\.]\+.\?$/\1/'`" ;;
48     *.fc9*)        verrel="`echo ${verrel} | sed -e 's/^\(.*.fc9[^\.]*\)\.[^\.]\+.\?$/\1/'`" ;;
49   esac
50 }
51
52 print_verrel ()
53 {
54   get_verrel $@
55   echo "${verrel}"
56 }
57
58 get_variant ()
59 {
60   get_verrel $@
61   variant=${1:-$(uname -r)}
62   variant=${variant##$verrel}
63   variant=${variant:-'""'}
64 }
65
66 print_variant ()
67 {
68   get_variant $@
69   echo "${variant}"
70 }
71
72
73 get_rpmtemplate ()
74 {
75     local variant="${1}"
76     local dashvariant="${variant:+-${variant}}"
77     case "$verrel" in
78         *.el[6-9]*)
79                kdep="kernel-%{_target_cpu} = ${verrel}${variant}"     ;;
80         *.EL*) kdep="kernel${dashvariant}-%{_target_cpu} = ${verrel}" ;;
81         *)     kdep="kernel-%{_target_cpu} = ${verrel}${variant}"     ;;
82     esac
83     case "$verrel" in
84         *.el[6-9]*)
85                   kname="${verrel}.%{_target_cpu}${variant:+.${variant}}" ;;
86         *.fc[1-9][0-9]*)
87                   kname="${verrel}.%{_target_cpu}${variant:+.${variant}}" ;;
88         *.fc9*)   kname="${verrel}.%{_target_cpu}${variant:+.${variant}}" ;;
89         *)        kname="${verrel}${variant}"                             ;;
90     esac
91
92     cat <<EOF
93 %package       -n kmod-${kmod_name}${dashvariant}
94 Summary:          ${kmod_name} kernel module(s)
95 Group:            System Environment/Kernel
96 Provides:         kernel-modules = ${kname}
97 Provides:         ${kmod_name}-kmod = %{?epoch:%{epoch}:}%{version}-%{release}
98 Provides:         openafs-kernel = %{PACKAGE_VERSION}
99 Requires:         ${kdep}
100 Requires:         ${kmod_name}-kmod-common >= %{?epoch:%{epoch}:}%{version}
101 Requires(post):   /sbin/depmod
102 Requires(postun): /sbin/depmod
103 Release:          %{pkgrel}.%(echo ${verrel} | tr - _)
104 BuildRequires:    kernel${dashvariant}-devel-%{_target_cpu} = ${verrel}
105 %description   -n kmod-${kmod_name}${dashvariant}
106 This package provides the ${kmod_name} kernel modules built for the Linux
107 kernel ${kname} for the %{_target_cpu} family of processors.
108 %post          -n kmod-${kmod_name}${dashvariant}
109 /sbin/depmod -aeF /boot/System.map-${kname} ${kname} > /dev/null || :
110 %postun        -n kmod-${kmod_name}${dashvariant}
111 /sbin/depmod -aF /boot/System.map-${kname} ${kname} &> /dev/null || :
112 %files         -n kmod-${kmod_name}${dashvariant}
113 %defattr(644,root,root,755)
114 /lib/modules/${kname}/extra/${kmod_name}/
115
116 EOF
117 }
118
119 print_rpmtemplate ()
120 {
121   kmod_name="${1}"
122   shift
123   kver="${1}"
124   get_verrel "${1}"
125   shift
126   if [ -z "${kmod_name}" ] ; then
127     echo "Please provide the kmodule-name as first parameter." >&2
128     exit 2
129   elif [ -z "${kver}" ] ; then
130     echo "Please provide the kver as second parameter." >&2
131     exit 2
132   elif [ -z "${verrel}" ] ; then
133     echo "Couldn't find out the verrel." >&2
134     exit 2
135   fi
136
137   for variant in "$@" ; do
138     get_rpmtemplate "${variant}"
139   done
140 }
141
142 usage ()
143 {
144   cat <<EOF
145 You called: ${invocation}
146
147 Usage: ${myprog} <command> <option>+
148  Commands:
149   verrel <uname>                               
150     - Get "base" version-release.
151   variant <uname>                               
152     - Get variant from uname.
153   rpmtemplate <mainpgkname> <uname> <variants> 
154     - Return a template for
155   version  
156     - Output version number and exit.
157 EOF
158 }
159
160 invocation="$(basename ${0}) $@"
161 while [ "${1}" ] ; do
162   case "${1}" in
163     verrel)
164       shift
165       print_verrel $@
166       exit $?
167       ;;
168     variant)
169       shift
170       print_variant $@
171       exit $?
172       ;;
173     rpmtemplate)
174       shift
175       print_rpmtemplate "$@"
176       exit $?
177       ;;
178     version)
179       echo "${myprog} ${myver}"
180       exit 0
181       ;;
182     *)
183       echo "Error: Unknown option '${1}'." >&2
184       usage >&2
185       exit 2
186       ;;
187   esac
188 done
189
190 # Local variables:
191 # mode: sh
192 # sh-indentation: 2
193 # indent-tabs-mode: nil
194 # End:
195 # ex: ts=2 sw=2 et